diff --git a/fs/seq_file.c b/fs/seq_file.c
index c4856d7c7db59..fbcadd731e452 100644
--- a/fs/seq_file.c
+++ b/fs/seq_file.c
@@ -221,8 +221,10 @@ ssize_t seq_read(struct file *file, char __user *buf, size_t size, loff_t *ppos)
 		size -= n;
 		buf += n;
 		copied += n;
-		if (!m->count)
+		if (!m->count) {
+			m->from = 0;
 			m->index++;
+		}
 		if (!size)
 			goto Done;
 	}
